#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <algorithm>

using namespace std;

const int maxn = 200001;
const int len = 102;

int n,k,t,w[maxn],b[maxn];
int g[len],next[maxn];
int vis[30001][len];

void Qsort(int l, int r)
{
   if (l >= r) return;
   int i=l,j=r,k=b[l+rand()%(r-l+1)];
   while (i < j) {
      while (b[i] < k) i++;
      while (b[j] > k) j--;
      if (i <= j) {swap(w[i],w[j]); swap(b[i],b[j]); i++; j--;}
   }
   if (l < j) Qsort(l,j);
   if (i < r) Qsort(i,r);
}

void TryIt(int i, int j1, int j2)
{
   if (j1 == j2) vis[i+1][j1] = 1;
   else {
      int j = min(j1,j2);
      if ((!g[j] || b[g[j]] >= i+t) && (i+t <= 30000)) vis[i+t][j2] = 1;
   }
}

int main()
{
   int i,j;

   freopen("input.txt","rt",stdin); freopen("output.txt","wt",stdout);
   scanf("%d%d%d",&k,&n,&t);
   for (i = 1; i <= n; i++) scanf("%d%d",&w[i],&b[i]);
   
   Qsort(1,n); memset(g,0,sizeof(g));
   for (i = n; i >= 1; i--) {
      next[i] = g[w[i]]; g[w[i]] = i;
   }

   memset(vis,0,sizeof(vis));
   vis[0][1] = 1;
   for (i = 0; i <= 30000; i++) {
      for (j = 1; j <= k; j++)
         while (g[j] && b[g[j]] <= i) g[j] = next[g[j]];
      for (j = 1; j <= k+1; j++)
         if (vis[i][j]) {
            if (j != 1) TryIt(i,j,j-1);
            if (j != k+1) TryIt(i,j,j+1);
            if (j == 1) TryIt(i,j,j);
         }
   }
   
   for (i = 1; i <= 30000; i++) 
      if (vis[i][k+1]) {printf("%d",i); break;}

   fclose(stdin); fclose(stdout);
   return 0;
}